#include <stdio.h>
#include <stdlib.h>
#include <iostream.h>
#include <conio.h>

const int BUF_SIZE = 256;
const int BUF_HALF = BUF_SIZE/2;
const int SBUF_SIZE = 16;
const int RESIZE = BUF_HALF/SBUF_SIZE;
const int FEEDBACKS_MAX = 12;

//BUFHALF>SBUF_SIZE>FEEDBACLS_MAX

const int ADPCM_UNIT = 64;

const int printf_mask = 0x0FFF;

int dither_prob[16] = {0};

struct adpcm_common{
 double wav_buf[BUF_SIZE];
 double psycho_ac_big[BUF_HALF];
 double psycho_ac[SBUF_SIZE];
 double feedbacks[SBUF_SIZE];
 double errors_bf[SBUF_SIZE+1];
 double ath_curve_big[BUF_HALF];
 double ath_curve[SBUF_SIZE];
 double mask_spread_for[BUF_HALF];
 double mask_spread_rev[BUF_HALF];
 double mask_spread_norm[BUF_HALF];

 char wav_comp[ADPCM_UNIT];
 int sign_hist[4];
 double distl_hist[16];//ŋ}~@ɂړ(MAX)
 double dists_hist[16];//̈ړ̌덷͈(ŌMIN)
 double play_volume;
 double sampling_rate;
 double dither_magnitude;
 int meaningful_sbuf;
 //wav_buf ݃GR[h悤ƂĂ錳g`0`ADPCM_UNIT-1ɁA
 //        ꂩ̖̔g``BUF_SIZE-1܂œĂB
 //psycho_ac 0`TvOg2[Hz]܂ł̎gƂ̋emCY
 //          (}XLOl)ĂBjAB傫
 //          mCYƁAɂȂB
 //feedbacks tB[hobNWBfeedbacks[0]͕K1.0B
 //          feedbacks_max-1܂ŒlĂāAȍ~0.0B
 //errors_bf ςݏグG[Bwav_bufɃG[㏑ƁA
 //          ̔g`𒲂ׂȂȂ邽߁Aerror_bfɕۊǂB
 //ath_curve Ήl(ATH)BjAB
 //mask_spread }XLOBBUF_HALF̎gт̒ŁA1ш
 //            փ}XNLxB1barkшւ-10dBxA
 //            1barkႢшւ-25dBx}XNL炵B
 //mask_spread_norm ̂܂܃}XNLƁA͍L₷̂ŁA
 //                 Zƍ悪傫ȂĂ܂̂ŁAWB


 //wav_comp  8bitɈkʂi[B

};

int init_adpcm_common(struct adpcm_common *adpc){
 for(int i=0;i<BUF_SIZE;i++)adpc->wav_buf[i] = 0;
 for(int i=0;i<BUF_HALF;i++)adpc->psycho_ac_big[i] = 1000.0;
 for(int i=0;i<SBUF_SIZE;i++)adpc->psycho_ac[i] = 0;
 for(int i=0;i<SBUF_SIZE;i++)adpc->ath_curve[i] = 0;
 for(int i=0;i<SBUF_SIZE;i++)adpc->feedbacks[i] = 0;
 for(int i=0;i<=SBUF_SIZE;i++)adpc->errors_bf[i] = 0;
 for(int i=0;i<BUF_HALF;i++)adpc->ath_curve_big[i] = 0;
 for(int i=0;i<BUF_HALF;i++)adpc->mask_spread_for[i] = 0; //10dB/bark
 for(int i=0;i<BUF_HALF;i++)adpc->mask_spread_rev[i] = 0; //25dB/bark
 for(int i=0;i<BUF_HALF;i++)adpc->mask_spread_norm[i] = 0;
 for(int i=0;i<ADPCM_UNIT;i++)adpc->wav_comp[i] = 0;
 for(int i=0;i<4;i++)adpc->sign_hist[i] = 0;
 adpc->feedbacks[0] = 1.0;
 adpc->play_volume = pow(10.0,70.5/20.0);
 adpc->meaningful_sbuf = 0;
 adpc->dither_magnitude = 0.4/256.0;
 return 0;
}

double maxim(double a,double b){
 if(a>b)return a;
 return b;
}


int prepare_psycho_param(struct adpcm_common *adpc){
 // oS̃p[^ZoĊi[܂B1GR[hɂ1ĂׂOKB
 // ISO 226 :2003 standard 20phon
 //        bark             0   1    2    3    4    5    6    7    8    9    10   11   12   13   14   15   16   17   18   19   20   21   22   23    24    25    26    27    28
 //     double barkgen[27]={0, 100, 200, 300, 400, 510, 630, 770, 920, 1080,1270,1480,1720,2000,2320,2700,3150,3700,4400,5300,6400,7700,9500,12000,15500,27000,300000};
 const double athcgen[27] = {60, 46, 34,  28,  26,  23,  22,  21,  20,   20,  21,  22,  21,  19,  17,  16,  14,  15,  16,  19,  24,  30,  34,  34,   33,   81,   84};

 const double negligible_hz = 16300;

 adpc->meaningful_sbuf = 1+SBUF_SIZE*2*negligible_hz/adpc->sampling_rate;
 if(adpc->meaningful_sbuf>SBUF_SIZE)adpc->meaningful_sbuf = SBUF_SIZE;
 double hz = 0.3*adpc->sampling_rate/BUF_SIZE;
 double bark;
 double barkgen[BUF_HALF];
 int i,j;

 for(i=0;i<BUF_HALF;i++){
  bark = 13.0*atan(hz*0.00076)+3.5*atan((hz/7500.0)*(hz/7500.0));
  barkgen[i] = bark;
  double db = athcgen[(int)bark]+(bark-((int)bark))*(athcgen[1+(int)bark]-athcgen[(int)bark]);
  if(hz>negligible_hz) db = 95.0;//neglect more than 16.3kHz
  hz += adpc->sampling_rate/BUF_SIZE;

  adpc->ath_curve_big[i] = pow(10.0,db/20.0);
 }
 for(i=0;i<SBUF_SIZE;i++){
  double db_acum = 0.0;
  for(j=0;j<RESIZE;j++){
   db_acum += 1.0/adpc->ath_curve_big[i*RESIZE+j];
  }
  adpc->ath_curve[i] = db_acum/RESIZE;
 }

 for(i=0;i<BUF_HALF;i++){
  adpc->mask_spread_for[i] = 0.0;
  adpc->mask_spread_rev[i] = 0.0;
  if((i+1)<BUF_HALF)adpc->mask_spread_for[i] = pow(0.1,(barkgen[i+1]-barkgen[i])*0.5);//-10dB,-30dB
  if(i>0)adpc->mask_spread_rev[i] = pow(0.1,(barkgen[i]-barkgen[i-1])*1.5);
 }

 double mask_thre = 0.0;
 for(i=0;i<BUF_HALF;i++){
  mask_thre = maxim(1.0,mask_thre);
  adpc->mask_spread_norm[i] = mask_thre;
  mask_thre *= adpc->mask_spread_for[i];
 }
 mask_thre = 0.0;
 for(i=BUF_HALF-1;i>=0;i--){
  mask_thre = maxim(adpc->mask_spread_norm[i],mask_thre);
  adpc->mask_spread_norm[i] = mask_thre;
  mask_thre *= adpc->mask_spread_rev[i];
 }
 for(i=0;i<BUF_HALF;i++){
  adpc->mask_spread_norm[i] = 100.0*adpc->play_volume/(sqrt(BUF_HALF)*adpc->mask_spread_norm[i]);
 }

 return 0;
}

void fft1(double ar[], double ai[], int n, int iter, int flag){
	int i, it, j, j1, j2, k, xp, xp2;
	double arg, dr1, dr2, di1, di2, tr, ti, w, wr, wi;
/*
	if(n < 2)
	{
		printf("Error : n < 2  in fft1()\n");
		return;
	}
	if(iter <= 0)
	{
		iter = 0;
		i = n;
		while((i /= 2) != 0)	iter++;
	}
	j = 1;
	for(i = 0; i < iter; i++)	j *= 2;
	if(n != j)
	{
		printf("Error : n != 2 ^ k  in fft1()\n");
		return;
	}
*/
	w = (flag? M_PI: -M_PI) / (double)n;
	xp2 = n;
	for(it = 0; it < iter; it++)
	{
		xp = xp2;
		xp2 /= 2;
		w *= 2;
		for(k = 0, i = - xp; k < xp2; i++)
		{
			wr = cos(arg = w * k++);
			wi = sin(arg);
			for(j = xp; j <= n; j += xp)
			{
				j2 = (j1 = j + i) + xp2;
				tr = (dr1 = ar[j1]) - (dr2 = ar[j2]);
				ti = (di1 = ai[j1]) - (di2 = ai[j2]);
				ar[j1] = dr1 + dr2;
				ai[j1] = di1 + di2;
				ar[j2] = tr * wr - ti * wi;
				ai[j2] = ti * wr + tr * wi;
			}
		}
	}
	j = j1 = n / 2;
	j2 = n - 1;
	for(i = 1; i < j2; i++)
	{
		if(i < j)
		{
			w = ar[i];
			ar[i] = ar[j];
			ar[j] = w;
			w = ai[i];
			ai[i] = ai[j];
			ai[j] = w; 
		}
		k = j1;
		while(k <= j)
		{
			j -= k;
			k /= 2;
		}
		j += k;
	}
	if(flag==0)return;
	w = 1. / sqrt(n);
	for(i = 0; i < n; i++)
	{
		ar[i] *= w;
		ai[i] *= w;
	}
	return;
}


double eval_feedbacks(struct adpcm_common *adpc,double feedbacks[SBUF_SIZE]){
 double ar[SBUF_SIZE*2];
 double ai[SBUF_SIZE*2];
 double score = 0.0;
 double powr;
 double psy_rate;
 double qnoise_volume = adpc->play_volume/256.0;
 int i;
 //if(feedbacks[0]!=1.0)printf("!!!!!! !!!\r\n");
 for(i=0;i<FEEDBACKS_MAX;i++){
  ai[i] = 0.0;
  ar[i] = feedbacks[i];
 }
 for(;i<SBUF_SIZE*2;i++){
  ar[i] = ai[i] = 0.0;
 }

 fft1(ar,ai,SBUF_SIZE*2,5,0);
 for(i=0;i<SBUF_SIZE;i++){
  powr = sqrt(ar[i]*ar[i]+ai[i]*ai[i]+0.0625)*qnoise_volume;
  psy_rate = powr*adpc->psycho_ac[i];
  score += psy_rate;
 }
 return score/SBUF_SIZE;
}

double eval_feedbacks_alpha(struct adpcm_common *adpc,double feedbacks_deltaf[SBUF_SIZE],double dist){
 double feedbacks_temp[SBUF_SIZE];
 feedbacks_temp[0] = 1.0;
 for(int j=1;j<SBUF_SIZE;j++){
  feedbacks_temp[j] = adpc->feedbacks[j] - feedbacks_deltaf[j]*dist;
 }
 return eval_feedbacks(adpc,feedbacks_temp);
}


double optimize_feedbacks(struct adpcm_common *adpc){
 double feedbacks_new[SBUF_SIZE] = {0.0};
 double feedbacks_deltaf[SBUF_SIZE] = {0.0};
 double feedbacks_distance;
 double feedbacks_distance_base;
 double feedbacks_center_score;
 double feedbacks_base_score;
 double feedbacks_new_score;
 int i,j,k,l;
 int scale = 0;
 double dist;
 feedbacks_new[0] = feedbacks_deltaf[0] = 1.0;

 for(k=0;k<16;k++){
  feedbacks_center_score = feedbacks_base_score = eval_feedbacks(adpc,adpc->feedbacks);
  feedbacks_distance = 0.0;
  //steepest gradient method ŋ}~@
  for(i=1;i<FEEDBACKS_MAX;i++){
   for(j=0;j<SBUF_SIZE;j++)feedbacks_new[j] = adpc->feedbacks[j];
   feedbacks_new[i] += 0.00025;//delta
   feedbacks_deltaf[i] = eval_feedbacks(adpc,feedbacks_new)-feedbacks_center_score;
   feedbacks_distance += feedbacks_deltaf[i]*feedbacks_deltaf[i];
  }
  //Linear search T
  feedbacks_distance_base = 0.001/sqrt(feedbacks_distance);
  for(l=0;l<30;l++){
   dist = (1<<l)*feedbacks_distance_base;
   feedbacks_new_score = eval_feedbacks_alpha(adpc,feedbacks_deltaf,dist);
   if(feedbacks_new_score<feedbacks_center_score){
    feedbacks_center_score = feedbacks_new_score;
   }
   else{
    scale = l;
    break;
   }
  }
  //Golden section search @
  double gss_a = 0.0;
  if(scale>=3)gss_a = dist*0.25;
  double gss_c;
  double gss_d;
  double gss_b = dist;
  double gss_mid;
  const double gss_tau = (sqrt(5.0) - 1.0) / 2;//0.618
  gss_c = gss_b-gss_tau*(gss_b-gss_a);
  gss_d = gss_a+gss_tau*(gss_b-gss_a);
  double gss_c_score = eval_feedbacks_alpha(adpc,feedbacks_deltaf,gss_c);
  double gss_d_score = eval_feedbacks_alpha(adpc,feedbacks_deltaf,gss_d);

  for(l=0;l<5;l++){
   if(gss_c_score>gss_d_score){
    gss_a = gss_c;
    gss_c = gss_d;
    gss_c_score = gss_d_score;
    gss_d = gss_a+gss_tau*(gss_b-gss_a);
    gss_d_score = eval_feedbacks_alpha(adpc,feedbacks_deltaf,gss_d);
   }
   else{
    gss_b = gss_d;
    gss_d = gss_c;
    gss_d_score = gss_c_score;
    gss_c = gss_b-gss_tau*(gss_b-gss_a);
    gss_c_score = eval_feedbacks_alpha(adpc,feedbacks_deltaf,gss_c);
   }
  }
  gss_mid = (gss_a+gss_b)*0.5;

  if((adpc->sign_hist[0]&printf_mask)==0 && k==-1){
   double testalpha[14];
   double testalpha_max = -99999999999.9;
   double testalpha_min = 99999999999.9;
   
   for(j=0;j<14;j++){
    testalpha[j] = eval_feedbacks_alpha(adpc,feedbacks_deltaf,(double)(j-2)*0.1*dist);
    if(testalpha_min>testalpha[j])testalpha_min = testalpha[j];
    if(testalpha_max<testalpha[j])testalpha_max = testalpha[j];
   }
   for(j=0;j<14;j++){
    printf("%3.1f ",(testalpha[j]-testalpha_min)*9.9/(testalpha_max-testalpha_min));
   }
   printf("%f \r\n",(testalpha_max-testalpha_min)/testalpha_max);
  }

  if(gss_c_score>feedbacks_base_score){
   feedbacks_new_score = eval_feedbacks_alpha(adpc,feedbacks_deltaf,dist*0.001);
   if(feedbacks_new_score<=feedbacks_base_score){
    feedbacks_center_score = feedbacks_new_score;
    for(j=1;j<FEEDBACKS_MAX;j++){
     adpc->feedbacks[j] -= feedbacks_deltaf[j]*dist*0.001;
    }
   }
   else{
    //printf("!!!! !!\r\n");
   }
  }
  else{
   if(gss_c_score>gss_d_score){
    if(feedbacks_center_score>gss_d_score){
      feedbacks_center_score = gss_d_score;
      for(j=1;j<FEEDBACKS_MAX;j++){
       adpc->feedbacks[j] -= feedbacks_deltaf[j]*gss_d;
      }
    }
    else{
      for(j=1;j<FEEDBACKS_MAX;j++){
       adpc->feedbacks[j] -= feedbacks_deltaf[j]*dist*0.5;
      }
    }
   }
   else{
    if(feedbacks_center_score>gss_c_score){
      feedbacks_center_score = gss_c_score;
      for(j=1;j<FEEDBACKS_MAX;j++){
       adpc->feedbacks[j] -= feedbacks_deltaf[j]*gss_c;
      }
    }
    else{
      for(j=1;j<FEEDBACKS_MAX;j++){
       adpc->feedbacks[j] -= feedbacks_deltaf[j]*dist*0.5;
      }
    }
   }
  }
  if(adpc->distl_hist[k]<gss_b)adpc->distl_hist[k] = gss_b/feedbacks_distance_base;
  if(adpc->dists_hist[k]>scale)adpc->dists_hist[k] = (gss_b-gss_a)/feedbacks_distance_base;
  if((feedbacks_base_score - feedbacks_center_score)<(0.00002*(k+1.0)))break;
 }



 if((adpc->sign_hist[0]&printf_mask)==0){
  double ar[SBUF_SIZE*2];
  double ai[SBUF_SIZE*2];
  for(i=0;i<SBUF_SIZE;i++){
   ai[i] = 0;
   ar[i] = adpc->feedbacks[i];
  }
  for(i=SBUF_SIZE;i<SBUF_SIZE*2;i++){
   ar[i] = ai[i] = 0;
  }
  fft1(ar,ai,SBUF_SIZE*2,5,0);
  printf("feedback:");
  for(i=0;i<FEEDBACKS_MAX;i++){
   printf("%d ",(int)(adpc->feedbacks[i]*1000));
  }
  printf("\r\n masking:");
  for(i=0;i<SBUF_SIZE;i++){
   printf("%d ",(int)(-log10(adpc->psycho_ac[i])*(20.0)));
  }
  printf("\r\n   noise:");
  for(i=0;i<SBUF_SIZE;i++){
   printf("%d ",(int)(log10(sqrt(ar[i]*ar[i]+ai[i]*ai[i]))*20.0));
  }
  //printf("\r\n   score:");
  //printf("%f ",feedbacks_center_score);

  printf("\r\n   start:");
  i = 0;
  while(adpc->distl_hist[i]!=-1 && i<16){
   printf("%5.1f",adpc->distl_hist[i++]);
  }
  printf("\r\n     end:");
  i = 0;
  while(adpc->dists_hist[i]!=9999 && i<16){
   printf("%5.1f",adpc->dists_hist[i++]);
  }
  printf("\r\n");

 }

 return feedbacks_center_score;
}

int adpcm(struct adpcm_common *adpc){
 double ar[BUF_SIZE];
 double ai[BUF_SIZE];
 double psycho_ac_tmp[BUF_HALF];
 int psycho_ac_shrink_shift = 0;
 while((1<<psycho_ac_shrink_shift)<RESIZE)psycho_ac_shrink_shift++;


 int i,j;
 for(i=0;i<BUF_SIZE;i++){
  double sinw = sin((i+0.5)*3.141592653589/BUF_SIZE);
  ar[i] = adpc->wav_buf[i]*sinw*sinw;
  ai[i] = 0;
 }
 fft1(ar,ai,BUF_SIZE,8,0);
 double mask_thre;
 double biased_wav,error_wav,dithered_wav;
 int dequant_wav;
 int output_wav;
 mask_thre = 0.0;
 for(i=0;i<BUF_HALF;i++){
  mask_thre = maxim(sqrt(ar[i]*ar[i]+ai[i]*ai[i]),mask_thre);
  psycho_ac_tmp[i] = mask_thre;
  mask_thre *= adpc->mask_spread_for[i];
  if(i<SBUF_SIZE)adpc->psycho_ac[i] = 0.0;
 }
 mask_thre = 0.0;
 for(i=BUF_HALF-1;i>=0;i--){
  mask_thre = maxim(psycho_ac_tmp[i],mask_thre);
  psycho_ac_tmp[i] = mask_thre;
  mask_thre *= adpc->mask_spread_rev[i];
 }

 for(i=0;i<BUF_HALF;i++){
  adpc->psycho_ac_big[i] *= 0.9375;
  adpc->psycho_ac_big[i] += (psycho_ac_tmp[i]*adpc->mask_spread_norm[i])+adpc->ath_curve_big[i];
  adpc->psycho_ac[i>>psycho_ac_shrink_shift] += 16*RESIZE/(adpc->psycho_ac_big[i]);
 }
 adpc->psycho_ac[0] *= 2.0;

 for(i=0;i<16;i++){
  adpc->distl_hist[i] = -1;
  adpc->dists_hist[i] = 9999;
 }
 //double feedbacks_score;
 double quant_step = 256.0;
 int quant_step_int = 0;

 optimize_feedbacks(adpc);

 //feedbacks_score = optimize_feedbacks(adpc);
 //while((feedbacks_score*256.0)<quant_step && quant_step_int<7){
 // quant_step *= 0.5;
 // quant_step_int++;
 //}

 for(i=0;i<ADPCM_UNIT;i++){
  biased_wav = adpc->wav_buf[i]-adpc->errors_bf[1];

  double dither = atan(((double)rand()/RAND_MAX)*5.0-2.5)*0.0625;
  dither_prob[(int)((dither*100.0)+8.0)]++;

  dithered_wav = biased_wav + dither/quant_step;
  output_wav = (int)(100000.5+(dithered_wav*quant_step));
  output_wav -= 100000;
  dequant_wav = (output_wav<<quant_step_int);
  if(dequant_wav>127)dequant_wav = 127;
  if(dequant_wav<-127)dequant_wav = -127;

  error_wav = biased_wav-(dequant_wav/256.0);
  error_wav = tanh(error_wav*8.0)*0.125;// limit error
  for(j=1;j<FEEDBACKS_MAX;j++){
   adpc->errors_bf[j] = adpc->errors_bf[j+1];
   adpc->errors_bf[j] += error_wav*adpc->feedbacks[j];
  }
  dequant_wav += 128;
  adpc->wav_comp[i] = (char)dequant_wav;
 }
 if((adpc->sign_hist[0]&printf_mask)==0){
  printf("\r\n");
 }

 for(i=0;i<(BUF_SIZE-ADPCM_UNIT);i++){
  adpc->wav_buf[i] = adpc->wav_buf[i+ADPCM_UNIT];
 }
 return 0;
}


main(int argc, char **argv){
 char input_wav_path[4096] = "";
 char output_wav_path[4096] = "";
 int i,j,k,l;
 int input_sampling_rate;
 int input_wav_length;
 int intbuf;
 struct adpcm_common ADPC[8];
 struct adpcm_common *adpc[8];
 for(i=0;i<8;i++){
  adpc[i] = &ADPC[i];
  init_adpcm_common(adpc[i]);
 }
 short sbuf;
 FILE INPUT_WAV;
 FILE *input_wav;
 if(argc==1){
  printf("wav8bit.exe version 2.0.3 (http://d.hatena.ne.jp/kamedo2/)\r\n");
  printf("16bit wav file to 8bit wav file. Very slow, high quality.\r\n\r\n");
  printf("  usage:  wav8bit input.wav [output.wav]\r\n");
  return 0;
 }
 if(1<argc){
  strcpy(input_wav_path,argv[1]);
  strcpy(output_wav_path,input_wav_path);
  int path_len = strlen(output_wav_path)-4;
  if(output_wav_path[path_len]=='.'){
   output_wav_path[path_len] = 0;
  }
  strcat(output_wav_path,".8b.wav");
 }
 if(2<argc){
  strcpy(output_wav_path,argv[2]);
 }

 printf(" INPUT PATH:%s\r\n",input_wav_path);
 printf("OUTPUT PATH:%s\r\n",output_wav_path);
 if(strcmp(input_wav_path,output_wav_path)==0){
  printf("Input and output have the same path.\r\n");
  return 1;
 }

 char chunkstr[8] = {0};
 int chunk_length;
 int chunk_max = 10;
 if((input_wav = fopen(input_wav_path,"rb")) == NULL){
  printf("Input file does not exist.\r\n");
  return 1;
 }
 fread(chunkstr,1,4,input_wav);
 if(strcmp(chunkstr,"RIFF")!=0)printf("RIFF != %s\r\n",chunkstr);
 fread(chunkstr,1,4,input_wav);
 fread(chunkstr,1,4,input_wav);
 if(strcmp(chunkstr,"WAVE")!=0)printf("WAVE != %s\r\n",chunkstr);
 fread(chunkstr,1,4,input_wav);
 while(strcmp(chunkstr,"fmt ")!=0 && (chunk_max>0)){
  printf("fmt  != %s\r\n",chunkstr);
  fread(&chunk_length,4,1,input_wav);
  for(i=0;i<chunk_length;i++)fread(chunkstr,1,1,input_wav);
  fread(chunkstr,1,4,input_wav);
  chunk_max--;
 }

 int channel_number = 1;
 if(chunk_max){
  fread(&chunk_length,4,1,input_wav);
  fread(chunkstr,1,4,input_wav);
  if((chunkstr[0]!=1 || chunkstr[1]!=0) && (chunkstr[0]!=-2 || chunkstr[1]!=-1)){
   printf("This is not a linear PCM.\r\n");//WAVE_FORMAT_EXTENSIBLE
   return 2;//linear PCM
  }
  if(chunkstr[3]!=0 || chunkstr[2]>7 || chunkstr[2]==0){
   printf("Too many channel number.\r\n");
   return 3;//channel number error.
  }
  channel_number = chunkstr[2];
  fread(&input_sampling_rate,1,4,input_wav);
  fread(&intbuf,1,4,input_wav);
  if(intbuf!=input_sampling_rate*2*channel_number){
   printf("This is not a 16bit depth wave file.\r\n");
   return 4;//8bit,24bit...etc
  }
  for(i=0;i<chunk_length-12;i++)fread(chunkstr,1,1,input_wav);
 }

 fread(chunkstr,1,4,input_wav);
 while(strcmp(chunkstr,"data")!=0 && (chunk_max>0)){
  printf("data!=%s\r\n",chunkstr);
  fread(&chunk_length,4,1,input_wav);
  for(i=0;i<chunk_length;i++)fread(chunkstr,1,1,input_wav);
  fread(chunkstr,1,4,input_wav);
  chunk_max--;
 }
 if(chunk_max){
  fread(&input_wav_length,4,1,input_wav);
 }
 else{
  printf("There are no data chunk.\r\n");
  return 5;//8bit
 }

 input_wav_length /= (2*channel_number*ADPCM_UNIT);

 printf("SAMPLE RATE: %d\r\n",input_sampling_rate);
 printf(" FRAMES NUM: %d\r\n",input_wav_length);
 printf("CHANNEL NUM: %d\r\n",channel_number);
 for(l=0;l<channel_number;l++){
  adpc[l]->sampling_rate = input_sampling_rate;
  prepare_psycho_param(adpc[l]);
 }
 /*
 printf(" Hz:");
 for(i=0;i<BUF_HALF;i++){
  printf("%4.1f ",input_sampling_rate*(i+0.5)/BUF_SIZE);
 }
 printf("\r\nATH:");
 for(i=0;i<BUF_HALF;i++){
  printf("%4.1f ",adpc[0]->ath_curve[i]);
 }
 printf("\r\nMSP:");
 for(i=0;i<BUF_HALF;i++){
  printf("%4.3f ",adpc[0]->mask_spread[i]);
 }
 printf("\r\n");
 */

 FILE *output_wav;
 output_wav = fopen(output_wav_path,"wb");
 if(output_wav==NULL)return 4;
 fputs("RIFF",output_wav);
 intbuf = 44-8+(input_wav_length*ADPCM_UNIT)*channel_number;
 fwrite(&intbuf,4,1,output_wav);
 fputs("WAVE",output_wav);
 fputs("fmt ",output_wav);
 intbuf = 16;
 fwrite(&intbuf,4,1,output_wav);
 intbuf = 65536*channel_number+1;
 fwrite(&intbuf,4,1,output_wav);
 intbuf = input_sampling_rate;
 fwrite(&intbuf,4,1,output_wav);
 intbuf *= channel_number;
 fwrite(&intbuf,4,1,output_wav);
 intbuf = 65536*8+channel_number*1;
 fwrite(&intbuf,4,1,output_wav);
 fputs("data",output_wav);
 intbuf = input_wav_length*ADPCM_UNIT*channel_number;
 fwrite(&intbuf,4,1,output_wav);

 for(j=0;j<(BUF_SIZE/ADPCM_UNIT)-1;j++){
  for(k=0;k<ADPCM_UNIT;k++){
   for(l=0;l<channel_number;l++){
    fread(&sbuf,2,1,input_wav);
    adpc[l]->wav_buf[k+BUF_SIZE-ADPCM_UNIT] = ((double)sbuf)/65536.0;
   }
  }
  for(l=0;l<channel_number;l++){
   adpc[l]->sign_hist[0] = 0x80;
   adpcm(adpc[l]);
  }
 }

 for(j=0;j<input_wav_length;j++){
  if((j+(BUF_SIZE/ADPCM_UNIT)-1)<input_wav_length){
   for(k=0;k<ADPCM_UNIT;k++){
    for(l=0;l<channel_number;l++){
     fread(&sbuf,2,1,input_wav);
     adpc[l]->wav_buf[k+BUF_SIZE-ADPCM_UNIT] = ((double)sbuf)/65536.0;
    }
   }
  }
  else{
   for(k=0;k<ADPCM_UNIT;k++){
    for(l=0;l<channel_number;l++){
     adpc[l]->wav_buf[k+BUF_SIZE-ADPCM_UNIT] = 0.0;
    }
   }
  }
  if((j&printf_mask)==0)printf("%4.1f\%\r\n",j*100.0/input_wav_length);


  for(l=0;l<channel_number;l++){
   adpc[l]->sign_hist[0] = j;
   adpcm(adpc[l]);
  }

  for(k=0;k<ADPCM_UNIT;k++){
   for(l=0;l<channel_number;l++){
    fwrite(&(adpc[l]->wav_comp[k]),1,1,output_wav);
   }
  }
 }

 for(l=0;l<16;l++){
  printf("%d ",dither_prob[l]);
 }



 fclose(input_wav);
 fclose(output_wav);
 return 0;
}

